﻿using GrapeCity.Documents.Drawing;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Pdf.AcroForms;
using GrapeCity.Documents.Pdf.Annotations;
using System;
using System.Drawing;
using System.IO;
using System.Security.Cryptography.X509Certificates;
using System.Linq;
using GrapeCity.Documents.Text;

namespace AddSecurity
{
    class Program
    {
       
        static void Main(string[] args)
        {


            var doc = new GcPdfDocument();
            using (FileStream stream = new FileStream(@"ModifiedPDF.pdf", FileMode.Create))
            using (var fs = new FileStream("TimeSheetForm.pdf", FileMode.Open, FileAccess.Read))
            {
                doc.Load(fs);
                var g = doc.Pages[0].Graphics;
                var page = doc.Pages.Last;

                //Add Owner Password/User Password
                var std = new GrapeCity.Documents.Pdf.Security.StandardSecurityHandlerRev2();
                std.OwnerPassword = "MA&3424";
                std.UserPassword = "EMP&7644";
                std.AllowPrint = false;
                std.AllowCopyContent = false;
                doc.Security.EncryptHandler = std;
               
                //Rotate the graphics so that Watermark is displayed as rotated
                g.Transform = System.Numerics.Matrix3x2.CreateRotation(
                (float)(-55 * Math.PI) / 180f,
                new System.Numerics.Vector2(page.Bounds.Width / 2, page.Bounds.Height / 2));
                //Add Watermark image
                var image = Image.FromFile("top-secret77.png");
                var align = ImageAlign.CenterImage;
                g.DrawImage(image, page.Bounds, null, align);
                                
                
                //Add digital signature
                var pfxPath = Path.Combine("GcPdfTest.pfx");
                X509Certificate2 cert = new X509Certificate2(File.ReadAllBytes(pfxPath), "qq",
                    X509KeyStorageFlags.MachineKeySet | X509KeyStorageFlags.PersistKeySet | X509KeyStorageFlags.Exportable);
                SignatureProperties sp = new SignatureProperties();
                sp.Certificate = cert;

                sp.SignerName = "Jane Donahue";
                sp.SigningDateTime = DateTime.Now;
                //look for the Signature Field that needs signing, supSign in this case
                SignatureField supSign = doc.AcroForm.Fields.First(f_ => f_.Name == "supSign") as SignatureField;
                sp.SignatureField = supSign;
                supSign.Widget.ButtonAppearance.Caption = "Jane Donahue";

                supSign.Widget.Rect = supSign.Widget.Rect;

                TextField date = doc.AcroForm.Fields.First(f_ => f_.Name == "supSignDate") as TextField;
                page.Graphics.DrawString(date.Value, new TextFormat() { FontName = "Arial", FontSize = 9 }, date.Widget.Rect);
                date.Value = sp.SigningDateTime.ToString();
                        
                doc.Sign(sp, stream);
                
            }




        }
    }
}
